using System;
using System.Text;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class CallBackServerTime : System.Web.UI.Page , ICallbackEventHandler
{
    protected void Page_Load(object sender, EventArgs e)
    {
        //Write JavaScript to the document.
        registerJScript();

        //Assign the Text Box Value to the Arugments to be posted back.
        string argument = "";

        //retrieve the javascript method call declaration generated for us
        string scriptDeclaration = this.ClientScript.GetCallbackEventReference(this, argument, "FetchServerTime", "null", "ErrorCallback", false);

        //Wire up Call back event two the onClick on the button.
        this.Button1.Attributes.Add("onclick", scriptDeclaration + "; return false;");
    }
    internal void registerJScript()
    {
        StringBuilder jscript = new StringBuilder();
        jscript.Append("<script language=\"javascript\">");
        //If an exception occurs on the server display the error message to the user.
        jscript.Append("function ErrorCallback(message){");
        jscript.Append("alert('An error occurred on the server:'\n + message);}");

        //Assign the Data returned from the server to the DIV section called UserControlHolder
        jscript.Append(" function FetchServerTime(result, context){");
        jscript.Append("document.all['" + Label1.ClientID + "'].innerText = result;}");

        jscript.Append("</script>");

        //REgister the the Javascript, this method will prevent the Script from been registered more than once,
        //Note : The Key parameter must be unique to each block of JavaScript you wish to register.
        Page.RegisterClientScriptBlock("CallbackScript", jscript.ToString());
    }

    #region ICallbackEventHandler Members

    public string GetCallbackResult()
    {
        return DateTime.Now.ToString();
    }

    public void RaiseCallbackEvent(string eventArgument)
    {
        
    }

    #endregion
}
